<?php
namespace Elbotrade\Bundle\ContentBundle\Controller;

use Symfony\Component\HttpFoundation\Request;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Template;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;

class DealsBackendController extends DealsController
{

    /**
     * @Route("/elbotrade/deal/backend/list", name="elbotrade_deal_backend_list")
     * @Template()
     */
    public function indexAction()
    {

        $deals = $this->get('elbotrade.content_bundle.deal_finder')->findAllDeals();

        return [
            'deals' => $deals ? $deals : [],
        ];
    }

    /**
     * @Route("/elbotrade/deal/backend/show/{id}", name="elbotrade_deal_backend_show")
     * @Template()
     */
    public function showAction($id)
    {
        return parent::showAction($id); // TODO: Change the autogenerated stub
    }

    /**
     * @param Request $request
     * @return array
     * @Route("/elbotrade/deal/backend/create", name="elbotrade_deal_backend_create")
     * @Template();
     */
    public function createAction(Request $request)
    {

        $dealManager = $this->get('elbotrade.content_bundle.deal_manager');

        $deal = $dealManager->createDeal();

        $form = $this->createForm(
            $this->get('elbotrade_content.deal.form.type'), null, ['action' => $this->generateUrl('elbotrade_deal_backend_create')]
        );

        if ($request->isMethod(Request::METHOD_POST)) {
            $dealManager = $this->get('elbotrade.content_bundle.deal_manager');
            if ($dealId = $dealManager->handleDealForm($form, $deal, $request)) {
                $response = $this->redirect($this->generateUrl('elbotrade_deal_backend_list', ['id' => $dealId]));
                return $response;
            }
        }

        $form->setData($deal);

        return [
            'form' => $form->createView(),
            'images' => $deal->getImage() ? $deal->getImage() : [],
        ];

    }

    /**
     * @param Request $request
     * @param $id
     * @Route("/elbotrade/deal/backend/update/{id}", name="elbotrade_deal_backend_update")
     * @Template("ElbotradeContentBundle:DealsBackend:update.html.twig")
     * @return array|\Symfony\Component\HttpFoundation\RedirectResponse
     */
    public function updateAction(Request $request, $id)
    {

        $dealFinder = $this->get('elbotrade.content_bundle.deal_finder');

        $deal = $dealFinder->findDeal($id);

        $form = $this->createForm(
            $this->get('elbotrade_content.deal.form.type'), null, ['action' => $this->generateUrl('elbotrade_deal_backend_update', ['id' => $id])]
        );

        if ($request->isMethod(Request::METHOD_POST)) {
            $dealManager = $this->get('elbotrade.content_bundle.deal_manager');
            if ($dealId = $dealManager->handleDealForm($form, $deal, $request)) {
                $response = $this->redirect($this->generateUrl('elbotrade_deal_backend_show', ['id' => $dealId]));
                return $response;
            }
        }

        $form->setData($deal);

        return [
            'form' => $form->createView(),
            'images' => $deal->getImage() ? $deal->getImage() : [],
        ];

    }

    /**
     * @Route("/elbotrade/deal/backend/delete/{id}", name="elbotrade_deal_backend_delete")
     */
    public function deleteAction($id)
    {

        $deal = $this->get('elbotrade.content_bundle.deal_finder')->findDeal($id);

        $this->getDoctrine()->getManager()->remove($deal);
        $this->getDoctrine()->getManager()->flush();

        $flashService = $this->get('elbotrade_product.services.flash_service');

        $flashService->setFlash('success', 'Deal Deleted');

        return $this->redirect($this->generateUrl('elbotrade_deal_backend_list'));
    }
}